> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://docs.itential.com/itential-platform/6/api-reference/guides/url-query-parameters/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.itential.com/_mcp/server. # URL query parameters > How to define and use URL query parameters in Itential Platform API methods. URL query parameters allow you to pass values through the API via the URL in the format `?key=value`. They also work within encoded URLs. To use URL query parameters: #### Define a query parameters object in pronghorn.json In the `pronghorn.json`, define a parameter with type `object`. This object will contain all query parameters. #### Add properties to the schema Add all properties you want to access via the URL as properties inside the schema. Include a data type so the URL parameter is correctly parsed. #### Define required parameters Determine which parameters are required — for example, those with no default value. If required parameters are not included in the request, the API will return an error. #### Reference query parameters in your function Reference the query parameters in the function as properties of the originally defined object parameter. **Example `pronghorn.json` method input:** ```json { "input": [ { "type": "object", "name": "queryParameters", "description": "description of query parameters", "schema": { "type": "object", "properties": { "stringField": { "type": "string" }, "numberField": { "type": "integer" }, "booleanField": { "type": "boolean" }, "arrayField": { "type": "array" }, "objectField": { "type": "object" } }, "required": [ "stringField", "numberField", "objectField" ] } } ] } ``` **Example function call:** ``` http://example_url/route?stringField=hello&numberField=7&booleanField=true&objectField[key]=value ``` **Example object passed into function:** ```json { "stringField": "hello", "numberField": 7, "booleanField": true, "objectField": { "key": "value" } } ``` ## Passing objects in URLs While using objects in URLs is not recommended, it can be done in one of two ways: 1. As a JSON string: ``` ?objectField={"key":"value"} ``` 2. In square-brackets notation: ``` ?objectField[key]=value ``` ## Order of operations If parameters are passed through both the request body and the URL query string, the request body takes priority and the query parameters are ignored entirely. In the following example, the value of the string parameter will be `world`: ```json { "options": { "string": "world" } } ``` ``` URL: http://example_url?string=hello ``` URL query parameters can be used with all request types (POST, GET, DELETE, PUT), but are recommended primarily for GET requests. > How to define and use URL query parameters in Itential Platform API methods.